import '../lib/dna.dart';

const int SDL_INIT_TIMER = 0x00000001;
const int SDL_INIT_AUDIO =  0x00000010;
const int SDL_INIT_VIDEO = 0x00000020;  /**< SDL_INIT_VIDEO implies SDL_INIT_EVENTS */
const int SDL_INIT_JOYSTICK = 0x00000200;  /**< SDL_INIT_JOYSTICK implies SDL_INIT_EVENTS */
const int SDL_INIT_HAPTIC = 0x00001000;
const int SDL_INIT_GAMECONTROLLER = 0x00002000;  /**< SDL_INIT_GAMECONTROLLER implies SDL_INIT_JOYSTICK */
const int SDL_INIT_EVENTS = 0x00004000;
const int SDL_INIT_NOPARACHUTE = 0x00100000;  /**< Don't catch fatal signals */
const int SDL_INIT_EVERYTHING  = SDL_INIT_TIMER | SDL_INIT_AUDIO | SDL_INIT_VIDEO | SDL_INIT_EVENTS |
SDL_INIT_JOYSTICK | SDL_INIT_HAPTIC | SDL_INIT_GAMECONTROLLER;

const int SDL_WINDOW_FULLSCREEN = 0x00000001;         /**< fullscreen window */
const int SDL_WINDOW_OPENGL = 0x00000002;             /**< window usable with OpenGL context */
const int SDL_WINDOW_SHOWN = 0x00000004;              /**< window is visible */
const int SDL_WINDOW_HIDDEN = 0x00000008;             /**< window is not visible */
const int SDL_WINDOW_BORDERLESS = 0x00000010;         /**< no window decoration */
const int SDL_WINDOW_RESIZABLE = 0x00000020;          /**< window can be resized */
const int SDL_WINDOW_MINIMIZED = 0x00000040;          /**< window is minimized */
const int SDL_WINDOW_MAXIMIZED = 0x00000080;          /**< window is maximized */
const int SDL_WINDOW_INPUT_GRABBED = 0x00000100;      /**< window has grabbed input focus */
const int SDL_WINDOW_INPUT_FOCUS = 0x00000200;        /**< window has input focus */
const int SDL_WINDOW_MOUSE_FOCUS = 0x00000400;        /**< window has mouse focus */
const int SDL_WINDOW_FULLSCREEN_DESKTOP = ( SDL_WINDOW_FULLSCREEN | 0x00001000 );
const int SDL_WINDOW_FOREIGN = 0x00000800;            /**< window not created by SDL */

@Lib('libSDL2.so')
class Sdl {
  dynamic lib = new DynamicLibrary<Sdl>();

  int SDL_Init(int flags) { return lib.SDL_Init(flags); }
  int SDL_InitSubSystem(int flags) { return lib.SDL_InitSubSystem(flags); }
  void SDL_QuitSubSystem(int flags) { return lib.SDL_QuitSubSystem(flags); }
  int SDL_WasInit(int flags) { return lib.SDL_WasInit(flags); }
  void SDL_Quit() { return lib.SDL_Quit(); }

  int SDL_CreateWindow(@Arg(ARG_STRING) String title, int x, int y, int w, int h, int flags) { return lib.SDL_CreateWindow(title, x, y, w, h, flags); }
  void SDL_ShowWindow(int window) { return lib.SDL_ShowWindow(window); }
  void SDL_DestroyWindow(int window) { return lib.SDL_DestroyWindow(window); }
  void SDL_HideWindow(int window) { return lib.SDL_HideWindow(window); }
  void SDL_RaiseWindow(int window) { return lib.SDL_RaiseWindow(window); }
  void SDL_MaximizeWindow(int window) { return lib.SDL_MaximizeWindow(window); }
  void SDL_MinimizeWindow(int window) { return lib.SDL_MinimizeWindow(window); }
  void SDL_RestoreWindow(int window) { return lib.SDL_RestoreWindow(window); }
  int SDL_SetWindowFullscreen(int window, int flags) { return lib.SDL_SetWindowFullscreen(window, flags); }

  int SDL_PollEvent(@Arg(ARG_STRUCT) @Out() Ref<SDL_Event> e) { return lib.SDL_PollEvent(e); }
}

@Struct()
class SDL_Event {
  @Field(ARG_INT, index: 0)
  int type;
}