import '../lib/dna.dart';

void main(){
  print('sizes ${nGetSizes()}');
  print('st ${encode(new SumSt(1,2,3))}');

  var sums = new Sums();
  var res =  sums.sumStPtr(new SumSt(1,2,3));
  print('sumStPtr lib $res');

  var library = nLoadLibrary('dna');

  var sum = nFindSymbol(library, 'sum');
  var vm = nCreateCallVM(256);
  nArgs(vm, 'ii', [1,2]);
  res= nCall(vm, sum, 'i');
  print('sum $res');
  nFreeCallVM(vm);

  var sum2 = nFindSymbol(library, 'sumSt');
  vm = nCreateCallVM(256);
  nArgs(vm, 'cccccc', [1,2,3,4,5,6]);
  res = nCall(vm, sum2, 'i');
  print('sumSt $res');
  nFreeCallVM(vm);

  var sum3 = nFindSymbol(library, 'sumStPtr');
  vm = nCreateCallVM(256);
  var st = nBuildStruct('cic', [1,2,3]);
  nArgs(vm, 'p', [st]);
  res= nCall(vm, sum3, 'i');
  print('sumStPtr $res');
  nFreeCallVM(vm);

  nFreeLibrary(library);
}

@Lib('libdna.so')
class Sums {
  dynamic lib = new DynamicLibrary<Sums>();

  int sumStPtr(@Arg(ARG_STRUCT) SumSt st) { return lib.sumStPtr(st); }
}

@Struct()
class SumSt {
  @Field(ARG_CHAR, 0)
  int a;
  @Field(ARG_INT, 1)
  int c;
  @Field(ARG_CHAR, 2)
  int b;

  SumSt(this.a, this.b, this.c);
}