// Copyright (c) 2016, root ext. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

/// Dart Native Access
library dna;

import 'dart-ext:dna';
import 'dart:typed_data';
import 'dart:mirrors';

part 'library.dart';
part 'model/pointer.dart';
part 'model/lib.dart';
part 'model/arg.dart';
part 'model/out.dart';
part 'model/ref.dart';
part 'model/ret.dart';
part 'model/struct.dart';
part 'model/field.dart';
part 'model/schema.dart';
part 'util.dart';
part 'coder.dart';

const int ARG_VOID = 86;
const int ARG_CHAR = 99;
const int ARG_UCHAR = 67;
const int ARG_SHORT = 115;
const int ARG_USHORT = 83;
const int ARG_INT = 105;
const int ARG_UINT = 73;
const int ARG_LONG = 106;
const int ARG_ULONG = 74;
const int ARG_LONGLONG = 108;
const int ARG_ULONGLONG = 76;
const int ARG_FLOAT = 102;
const int ARG_DOUBLE = 100;
const int ARG_BOOL = 66;

const int ARG_POINTER = 112;
const int ARG_STRING = 90;
const int ARG_TYPEDDATA = 68;
const int ARG_LISTINT = 88;
const int ARG_LISTSTRING = 89;
const int ARG_STRUCT = 84;

const int ARG_1BYTE = 49;
const int ARG_2BYTES = 50;
const int ARG_3BYTES = 52;
const int ARG_4BYTES = 56;

int nCreateCallVM(int size) native "nCreateCallVM";
void nFreeCallVM(int vm) native "nFreeCallVM";

void nArgs(int vm, String signature, List<Object> args) native "nArgs";
List<int> nGetSizes() native "nGetSizes";

dynamic nCall(int vm, int pointer, String signature) native "nCall";

int nLoadLibrary(String name) native "nLoadLibrary";
void nFreeLibrary(int lib) native "nFreeLibrary";
int nFindSymbol(int lib, String name) native "nFindSymbol";

int nDefineStruct(String signature) native "nDefineStruct";
int nBuildStruct(String signature, List<Object> args) native "nBuildStruct";
void nArgStruct(int vm, int struct, int pointer) native "nArgStruct";
int nCallStruct(int vm, int pointer, int struct) native "nCallStruct";

