// Copyright (c) 2016, root ext. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

import 'package:dna/dna.dart';
import 'package:test/test.dart';
import 'dart:io';

void main() {

  group('base tests', () {
    int library;

    setUp(() {
      if (!Platform.isLinux){
        print("unexpected OS");
        exit(0);
      }
      library = nLoadLibrary('libc.so.6');
    });

    tearDown(() {
      nFreeLibrary(library);
    });

    test('library', () {
      expect(library, isNonZero);
    });

    test('empty vm', () {
      var vm = nCreateCallVM(256);
      expect(vm, isNonZero);
      nFreeCallVM(vm);
    });

    test('getpid', () {
      var method = nFindSymbol(library, 'getpid');
      expect(method, isNonZero);
      var vm = nCreateCallVM(256);
      var processId = nCall(vm, method, new String.fromCharCodes([ARG_INT]));
      nFreeCallVM(vm);

      expect(processId, isNonZero);
      expect(processId, equals(pid));
    });


  });
}
